#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
}

MainWindow::~MainWindow()
{
    delete ui;
}

const int N = 8;
int a [N][N];

void move (int & i, void & j)
{
    if (j < N-1)
        j ++; // posun dolu ve sloupci
    else
    {
        j = 0; // nulta (prvni) (horni) radka
        i ++ ; // dalsi sloupec
        // na konci "prelezeme" na N-ty (n+1-ni) sloupec
    }
}

void test (int i, int j, /* pozice nove damy */
           int dx, int dy, /* smer postupu */
           bool & ok /* zda byla kolize, prirazujeme jen false */ )
{
    i += dx;
    j += dy; // jeden krok
    while (ok && 0 <= i && i <= N-1 && 0<=j && j <= N-1)
        // dokud nebyla kolize a jsme na sachovnici
    {
        if (a[i][j] > 0 ) ok = false; // potkali jsem damu
        if (a[i][j] < 0) break; // narazili jsme na prekazku

        i += dx;
        j += dy; // dalsi krok

    }
}


void place (int inx /* cislo damy (od 1 do N) */,
            int i /* cislo radky (od 0 do N-1) */,
            int j /* cislo sloupce, od kteho umistujeme damu */ )
{
    while (n < N && j < N)// dokud jsme na sachovnici
    {
        if (a[i][j] == 0) // pokud neni prekazka
        {

           // zkusime, zda damu na i, j nekoliduje
           bool ok = true; // ok .. zda byla kolize, jsme optimiste

           test (i, j, 0, -1, ok); // zkus cestu nahoru
           test (i, j, -1, 0, ok); // zkus cestu vlevo
           test (i, j, -1, -1, ok); // zkus cestu vlevo nahoru
           test (i, j, -1, 1, ok); // zkus cestu vlevo dolu
           // podemnou a vpravo jeste nic neni

           if (ok) // nebyla kolize, umistime dalsi damu)
           {
              a[i][j] = inx; // umistime nasi damu na i, j

              int ti = i;
              int tj = j;
              move (ti, tj); // ti, tj pozice pro dalsi damu

              if (inx < N && ti < N && tj < N)
                  // zbyva jeste nejaka dama a jeste jsme na sachovnici
                  place (inx +1, ti, tj) ; // zkusime umistit dalsi damu

              if (inx == N)
              {
                   // N dam je umisteno, nalezli jsem vysledek
              }

              a[i][j] = 0; // nasi damu odstranime
           }
        }

        // zkusit novou pozici
        move (i, j);
    }
}

void start ()
{
   // musi mit vyplnene pole a
   place (1, 0, 0); // prvni damu na 0, 0
}

void MainWindow::on_pushButton_clicked()
{

}
